"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compressStatusData = exports.compressDataBase64 = exports.compressData = void 0;
const pako_1 = __importDefault(require("pako"));
const buffer_1 = require("buffer");
const s3 = __importStar(require("../sgt/aws/lambda/s3upload_v1"));
const compressDataBase64 = (props) => {
    let { fileName, id, imageType, orderNumber, userName } = props;
    const s3data = s3.S3UploadData.encode({
        correlationId: id,
        imageType: imageType,
        filename: fileName,
        source: userName,
        description: "",
        contractor: 0,
        timezoneOffset: 0,
        dateTaken: undefined,
        gpsTimestamp: undefined,
        gpsDop: 0,
        gpsAltitude: 0,
        gpsLatitude: 0,
        gpsLongitude: 0,
        orderNumber: orderNumber,
        propertyId: undefined,
        category: "",
        prefix: "",
        departmentCode: "",
        vendorWebImageData: undefined,
        inspiImageData: undefined,
    }).finish();
    const gzippedData = pako_1.default.gzip(s3data);
    return buffer_1.Buffer.from(gzippedData).toString("base64");
};
exports.compressDataBase64 = compressDataBase64;
const compressData = (props) => {
    let { fileName, id, imageType, orderNumber, userName } = props;
    const s3data = s3.S3UploadData.encode({
        correlationId: id,
        imageType: imageType,
        filename: fileName,
        source: userName,
        description: "",
        contractor: 0,
        timezoneOffset: 0,
        dateTaken: undefined,
        gpsTimestamp: undefined,
        gpsDop: 0,
        gpsAltitude: 0,
        gpsLatitude: 0,
        gpsLongitude: 0,
        orderNumber: orderNumber,
        propertyId: undefined,
        category: "",
        prefix: "",
        departmentCode: "",
        vendorWebImageData: undefined,
        inspiImageData: undefined,
    }).finish();
    const gzippedData = pako_1.default.gzip(s3data);
    return gzippedData;
};
exports.compressData = compressData;
const compressStatusData = (props) => {
    let { id, orderNumber } = props;
    const s3data = s3.S3UploadStatusData.encode({
        correlationId: id,
        orderNumber: parseInt(orderNumber),
        propertyId: undefined,
    }).finish();
    const gzippedData = pako_1.default.gzip(s3data);
    return gzippedData;
};
exports.compressStatusData = compressStatusData;
