import * as _m0 from "protobufjs/minimal";
import { VendorWebImageData, InspiImageData } from "../../content/content_v2";
export declare const protobufPackage = "sgt.aws.lambda.s3upload.v1";
export interface S3UploadData {
    /** guid */
    correlationId: string;
    imageType: number;
    filename: string;
    source: string;
    description: string;
    category: string;
    prefix: string;
    contractor: number;
    departmentCode: string;
    timezoneOffset: number;
    dateTaken: Date | undefined;
    gpsTimestamp: Date | undefined;
    gpsDop: number;
    gpsAltitude: number;
    gpsLatitude: number;
    gpsLongitude: number;
    orderNumber: number | undefined;
    propertyId: number | undefined;
    vendorWebImageData: VendorWebImageData | undefined;
    inspiImageData: InspiImageData | undefined;
}
export interface S3ExifData {
    gpsDop: number;
    gpsAltitude: number;
    gpsLatitude: number;
    gpsLongitude: number;
    gpsTimestamp: Date | undefined;
    dateTimeOriginal: string;
    dateTimeDigitized: string;
    userComment: string;
    cameraMake: string;
    cameraModel: string;
    cameraOsVersion: string;
}
export interface S3SinkData {
    correlationId: string;
    success: boolean;
    message: string;
    s3Path: string;
    orderNumber: number | undefined;
    propertyId: number | undefined;
}
export interface S3RemoveData {
    s3Path: string;
}
export interface S3ProcessResult {
    results: S3ProcessResult_Result[];
}
export interface S3ProcessResult_Result {
    correlationId: string;
    filePath: string;
    fileSize: number;
    fileSha1: string;
    s3ExifData: S3ExifData | undefined;
    s3UploadData: S3UploadData | undefined;
    thumbnailPath: string;
    thumbnailSize: number;
    imageHeight: number;
    imageWidth: number;
    /** if either error_code or error_message != zero, nothing else is valid. */
    errorCode: number;
    errorMessage: string;
}
export interface S3UploadStatusData {
    correlationId: string;
    orderNumber: number | undefined;
    propertyId: number | undefined;
}
export declare const S3UploadData: {
    encode(message: S3UploadData, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): S3UploadData;
    fromJSON(object: any): S3UploadData;
    toJSON(message: S3UploadData): unknown;
    fromPartial<I extends {
        correlationId?: string | undefined;
        imageType?: number | undefined;
        filename?: string | undefined;
        source?: string | undefined;
        description?: string | undefined;
        category?: string | undefined;
        prefix?: string | undefined;
        contractor?: number | undefined;
        departmentCode?: string | undefined;
        timezoneOffset?: number | undefined;
        dateTaken?: Date | undefined;
        gpsTimestamp?: Date | undefined;
        gpsDop?: number | undefined;
        gpsAltitude?: number | undefined;
        gpsLatitude?: number | undefined;
        gpsLongitude?: number | undefined;
        orderNumber?: number | undefined;
        propertyId?: number | undefined;
        vendorWebImageData?: {
            statusReportId?: number | undefined;
            documentType?: string | undefined;
            sortOrder?: number | undefined;
            hashKey?: string | undefined;
            documentExtendedAttribute?: string | undefined;
            uploadKey?: string | undefined;
            annotationLabel?: string | undefined;
            annotationText?: string | undefined;
        } | undefined;
        inspiImageData?: {
            isFrontOfHouse?: boolean | undefined;
            mainVendorCode?: string | undefined;
            vendorCodeUploaded?: string | undefined;
        } | undefined;
    } & {
        correlationId?: string | undefined;
        imageType?: number | undefined;
        filename?: string | undefined;
        source?: string | undefined;
        description?: string | undefined;
        category?: string | undefined;
        prefix?: string | undefined;
        contractor?: number | undefined;
        departmentCode?: string | undefined;
        timezoneOffset?: number | undefined;
        dateTaken?: Date | undefined;
        gpsTimestamp?: Date | undefined;
        gpsDop?: number | undefined;
        gpsAltitude?: number | undefined;
        gpsLatitude?: number | undefined;
        gpsLongitude?: number | undefined;
        orderNumber?: number | undefined;
        propertyId?: number | undefined;
        vendorWebImageData?: ({
            statusReportId?: number | undefined;
            documentType?: string | undefined;
            sortOrder?: number | undefined;
            hashKey?: string | undefined;
            documentExtendedAttribute?: string | undefined;
            uploadKey?: string | undefined;
            annotationLabel?: string | undefined;
            annotationText?: string | undefined;
        } & {
            statusReportId?: number | undefined;
            documentType?: string | undefined;
            sortOrder?: number | undefined;
            hashKey?: string | undefined;
            documentExtendedAttribute?: string | undefined;
            uploadKey?: string | undefined;
            annotationLabel?: string | undefined;
            annotationText?: string | undefined;
        } & Record<Exclude<keyof I["vendorWebImageData"], keyof VendorWebImageData>, never>) | undefined;
        inspiImageData?: ({
            isFrontOfHouse?: boolean | undefined;
            mainVendorCode?: string | undefined;
            vendorCodeUploaded?: string | undefined;
        } & {
            isFrontOfHouse?: boolean | undefined;
            mainVendorCode?: string | undefined;
            vendorCodeUploaded?: string | undefined;
        } & Record<Exclude<keyof I["inspiImageData"], keyof InspiImageData>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof S3UploadData>, never>>(object: I): S3UploadData;
};
export declare const S3ExifData: {
    encode(message: S3ExifData, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): S3ExifData;
    fromJSON(object: any): S3ExifData;
    toJSON(message: S3ExifData): unknown;
    fromPartial<I extends {
        gpsDop?: number | undefined;
        gpsAltitude?: number | undefined;
        gpsLatitude?: number | undefined;
        gpsLongitude?: number | undefined;
        gpsTimestamp?: Date | undefined;
        dateTimeOriginal?: string | undefined;
        dateTimeDigitized?: string | undefined;
        userComment?: string | undefined;
        cameraMake?: string | undefined;
        cameraModel?: string | undefined;
        cameraOsVersion?: string | undefined;
    } & {
        gpsDop?: number | undefined;
        gpsAltitude?: number | undefined;
        gpsLatitude?: number | undefined;
        gpsLongitude?: number | undefined;
        gpsTimestamp?: Date | undefined;
        dateTimeOriginal?: string | undefined;
        dateTimeDigitized?: string | undefined;
        userComment?: string | undefined;
        cameraMake?: string | undefined;
        cameraModel?: string | undefined;
        cameraOsVersion?: string | undefined;
    } & Record<Exclude<keyof I, keyof S3ExifData>, never>>(object: I): S3ExifData;
};
export declare const S3SinkData: {
    encode(message: S3SinkData, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): S3SinkData;
    fromJSON(object: any): S3SinkData;
    toJSON(message: S3SinkData): unknown;
    fromPartial<I extends {
        correlationId?: string | undefined;
        success?: boolean | undefined;
        message?: string | undefined;
        s3Path?: string | undefined;
        orderNumber?: number | undefined;
        propertyId?: number | undefined;
    } & {
        correlationId?: string | undefined;
        success?: boolean | undefined;
        message?: string | undefined;
        s3Path?: string | undefined;
        orderNumber?: number | undefined;
        propertyId?: number | undefined;
    } & Record<Exclude<keyof I, keyof S3SinkData>, never>>(object: I): S3SinkData;
};
export declare const S3RemoveData: {
    encode(message: S3RemoveData, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): S3RemoveData;
    fromJSON(object: any): S3RemoveData;
    toJSON(message: S3RemoveData): unknown;
    fromPartial<I extends {
        s3Path?: string | undefined;
    } & {
        s3Path?: string | undefined;
    } & Record<Exclude<keyof I, "s3Path">, never>>(object: I): S3RemoveData;
};
export declare const S3ProcessResult: {
    encode(message: S3ProcessResult, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): S3ProcessResult;
    fromJSON(object: any): S3ProcessResult;
    toJSON(message: S3ProcessResult): unknown;
    fromPartial<I extends {
        results?: {
            correlationId?: string | undefined;
            filePath?: string | undefined;
            fileSize?: number | undefined;
            fileSha1?: string | undefined;
            s3ExifData?: {
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                gpsTimestamp?: Date | undefined;
                dateTimeOriginal?: string | undefined;
                dateTimeDigitized?: string | undefined;
                userComment?: string | undefined;
                cameraMake?: string | undefined;
                cameraModel?: string | undefined;
                cameraOsVersion?: string | undefined;
            } | undefined;
            s3UploadData?: {
                correlationId?: string | undefined;
                imageType?: number | undefined;
                filename?: string | undefined;
                source?: string | undefined;
                description?: string | undefined;
                category?: string | undefined;
                prefix?: string | undefined;
                contractor?: number | undefined;
                departmentCode?: string | undefined;
                timezoneOffset?: number | undefined;
                dateTaken?: Date | undefined;
                gpsTimestamp?: Date | undefined;
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                orderNumber?: number | undefined;
                propertyId?: number | undefined;
                vendorWebImageData?: {
                    statusReportId?: number | undefined;
                    documentType?: string | undefined;
                    sortOrder?: number | undefined;
                    hashKey?: string | undefined;
                    documentExtendedAttribute?: string | undefined;
                    uploadKey?: string | undefined;
                    annotationLabel?: string | undefined;
                    annotationText?: string | undefined;
                } | undefined;
                inspiImageData?: {
                    isFrontOfHouse?: boolean | undefined;
                    mainVendorCode?: string | undefined;
                    vendorCodeUploaded?: string | undefined;
                } | undefined;
            } | undefined;
            thumbnailPath?: string | undefined;
            thumbnailSize?: number | undefined;
            imageHeight?: number | undefined;
            imageWidth?: number | undefined;
            errorCode?: number | undefined;
            errorMessage?: string | undefined;
        }[] | undefined;
    } & {
        results?: ({
            correlationId?: string | undefined;
            filePath?: string | undefined;
            fileSize?: number | undefined;
            fileSha1?: string | undefined;
            s3ExifData?: {
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                gpsTimestamp?: Date | undefined;
                dateTimeOriginal?: string | undefined;
                dateTimeDigitized?: string | undefined;
                userComment?: string | undefined;
                cameraMake?: string | undefined;
                cameraModel?: string | undefined;
                cameraOsVersion?: string | undefined;
            } | undefined;
            s3UploadData?: {
                correlationId?: string | undefined;
                imageType?: number | undefined;
                filename?: string | undefined;
                source?: string | undefined;
                description?: string | undefined;
                category?: string | undefined;
                prefix?: string | undefined;
                contractor?: number | undefined;
                departmentCode?: string | undefined;
                timezoneOffset?: number | undefined;
                dateTaken?: Date | undefined;
                gpsTimestamp?: Date | undefined;
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                orderNumber?: number | undefined;
                propertyId?: number | undefined;
                vendorWebImageData?: {
                    statusReportId?: number | undefined;
                    documentType?: string | undefined;
                    sortOrder?: number | undefined;
                    hashKey?: string | undefined;
                    documentExtendedAttribute?: string | undefined;
                    uploadKey?: string | undefined;
                    annotationLabel?: string | undefined;
                    annotationText?: string | undefined;
                } | undefined;
                inspiImageData?: {
                    isFrontOfHouse?: boolean | undefined;
                    mainVendorCode?: string | undefined;
                    vendorCodeUploaded?: string | undefined;
                } | undefined;
            } | undefined;
            thumbnailPath?: string | undefined;
            thumbnailSize?: number | undefined;
            imageHeight?: number | undefined;
            imageWidth?: number | undefined;
            errorCode?: number | undefined;
            errorMessage?: string | undefined;
        }[] & ({
            correlationId?: string | undefined;
            filePath?: string | undefined;
            fileSize?: number | undefined;
            fileSha1?: string | undefined;
            s3ExifData?: {
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                gpsTimestamp?: Date | undefined;
                dateTimeOriginal?: string | undefined;
                dateTimeDigitized?: string | undefined;
                userComment?: string | undefined;
                cameraMake?: string | undefined;
                cameraModel?: string | undefined;
                cameraOsVersion?: string | undefined;
            } | undefined;
            s3UploadData?: {
                correlationId?: string | undefined;
                imageType?: number | undefined;
                filename?: string | undefined;
                source?: string | undefined;
                description?: string | undefined;
                category?: string | undefined;
                prefix?: string | undefined;
                contractor?: number | undefined;
                departmentCode?: string | undefined;
                timezoneOffset?: number | undefined;
                dateTaken?: Date | undefined;
                gpsTimestamp?: Date | undefined;
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                orderNumber?: number | undefined;
                propertyId?: number | undefined;
                vendorWebImageData?: {
                    statusReportId?: number | undefined;
                    documentType?: string | undefined;
                    sortOrder?: number | undefined;
                    hashKey?: string | undefined;
                    documentExtendedAttribute?: string | undefined;
                    uploadKey?: string | undefined;
                    annotationLabel?: string | undefined;
                    annotationText?: string | undefined;
                } | undefined;
                inspiImageData?: {
                    isFrontOfHouse?: boolean | undefined;
                    mainVendorCode?: string | undefined;
                    vendorCodeUploaded?: string | undefined;
                } | undefined;
            } | undefined;
            thumbnailPath?: string | undefined;
            thumbnailSize?: number | undefined;
            imageHeight?: number | undefined;
            imageWidth?: number | undefined;
            errorCode?: number | undefined;
            errorMessage?: string | undefined;
        } & {
            correlationId?: string | undefined;
            filePath?: string | undefined;
            fileSize?: number | undefined;
            fileSha1?: string | undefined;
            s3ExifData?: ({
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                gpsTimestamp?: Date | undefined;
                dateTimeOriginal?: string | undefined;
                dateTimeDigitized?: string | undefined;
                userComment?: string | undefined;
                cameraMake?: string | undefined;
                cameraModel?: string | undefined;
                cameraOsVersion?: string | undefined;
            } & {
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                gpsTimestamp?: Date | undefined;
                dateTimeOriginal?: string | undefined;
                dateTimeDigitized?: string | undefined;
                userComment?: string | undefined;
                cameraMake?: string | undefined;
                cameraModel?: string | undefined;
                cameraOsVersion?: string | undefined;
            } & Record<Exclude<keyof I["results"][number]["s3ExifData"], keyof S3ExifData>, never>) | undefined;
            s3UploadData?: ({
                correlationId?: string | undefined;
                imageType?: number | undefined;
                filename?: string | undefined;
                source?: string | undefined;
                description?: string | undefined;
                category?: string | undefined;
                prefix?: string | undefined;
                contractor?: number | undefined;
                departmentCode?: string | undefined;
                timezoneOffset?: number | undefined;
                dateTaken?: Date | undefined;
                gpsTimestamp?: Date | undefined;
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                orderNumber?: number | undefined;
                propertyId?: number | undefined;
                vendorWebImageData?: {
                    statusReportId?: number | undefined;
                    documentType?: string | undefined;
                    sortOrder?: number | undefined;
                    hashKey?: string | undefined;
                    documentExtendedAttribute?: string | undefined;
                    uploadKey?: string | undefined;
                    annotationLabel?: string | undefined;
                    annotationText?: string | undefined;
                } | undefined;
                inspiImageData?: {
                    isFrontOfHouse?: boolean | undefined;
                    mainVendorCode?: string | undefined;
                    vendorCodeUploaded?: string | undefined;
                } | undefined;
            } & {
                correlationId?: string | undefined;
                imageType?: number | undefined;
                filename?: string | undefined;
                source?: string | undefined;
                description?: string | undefined;
                category?: string | undefined;
                prefix?: string | undefined;
                contractor?: number | undefined;
                departmentCode?: string | undefined;
                timezoneOffset?: number | undefined;
                dateTaken?: Date | undefined;
                gpsTimestamp?: Date | undefined;
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                orderNumber?: number | undefined;
                propertyId?: number | undefined;
                vendorWebImageData?: ({
                    statusReportId?: number | undefined;
                    documentType?: string | undefined;
                    sortOrder?: number | undefined;
                    hashKey?: string | undefined;
                    documentExtendedAttribute?: string | undefined;
                    uploadKey?: string | undefined;
                    annotationLabel?: string | undefined;
                    annotationText?: string | undefined;
                } & {
                    statusReportId?: number | undefined;
                    documentType?: string | undefined;
                    sortOrder?: number | undefined;
                    hashKey?: string | undefined;
                    documentExtendedAttribute?: string | undefined;
                    uploadKey?: string | undefined;
                    annotationLabel?: string | undefined;
                    annotationText?: string | undefined;
                } & Record<Exclude<keyof I["results"][number]["s3UploadData"]["vendorWebImageData"], keyof VendorWebImageData>, never>) | undefined;
                inspiImageData?: ({
                    isFrontOfHouse?: boolean | undefined;
                    mainVendorCode?: string | undefined;
                    vendorCodeUploaded?: string | undefined;
                } & {
                    isFrontOfHouse?: boolean | undefined;
                    mainVendorCode?: string | undefined;
                    vendorCodeUploaded?: string | undefined;
                } & Record<Exclude<keyof I["results"][number]["s3UploadData"]["inspiImageData"], keyof InspiImageData>, never>) | undefined;
            } & Record<Exclude<keyof I["results"][number]["s3UploadData"], keyof S3UploadData>, never>) | undefined;
            thumbnailPath?: string | undefined;
            thumbnailSize?: number | undefined;
            imageHeight?: number | undefined;
            imageWidth?: number | undefined;
            errorCode?: number | undefined;
            errorMessage?: string | undefined;
        } & Record<Exclude<keyof I["results"][number], keyof S3ProcessResult_Result>, never>)[] & Record<Exclude<keyof I["results"], keyof {
            correlationId?: string | undefined;
            filePath?: string | undefined;
            fileSize?: number | undefined;
            fileSha1?: string | undefined;
            s3ExifData?: {
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                gpsTimestamp?: Date | undefined;
                dateTimeOriginal?: string | undefined;
                dateTimeDigitized?: string | undefined;
                userComment?: string | undefined;
                cameraMake?: string | undefined;
                cameraModel?: string | undefined;
                cameraOsVersion?: string | undefined;
            } | undefined;
            s3UploadData?: {
                correlationId?: string | undefined;
                imageType?: number | undefined;
                filename?: string | undefined;
                source?: string | undefined;
                description?: string | undefined;
                category?: string | undefined;
                prefix?: string | undefined;
                contractor?: number | undefined;
                departmentCode?: string | undefined;
                timezoneOffset?: number | undefined;
                dateTaken?: Date | undefined;
                gpsTimestamp?: Date | undefined;
                gpsDop?: number | undefined;
                gpsAltitude?: number | undefined;
                gpsLatitude?: number | undefined;
                gpsLongitude?: number | undefined;
                orderNumber?: number | undefined;
                propertyId?: number | undefined;
                vendorWebImageData?: {
                    statusReportId?: number | undefined;
                    documentType?: string | undefined;
                    sortOrder?: number | undefined;
                    hashKey?: string | undefined;
                    documentExtendedAttribute?: string | undefined;
                    uploadKey?: string | undefined;
                    annotationLabel?: string | undefined;
                    annotationText?: string | undefined;
                } | undefined;
                inspiImageData?: {
                    isFrontOfHouse?: boolean | undefined;
                    mainVendorCode?: string | undefined;
                    vendorCodeUploaded?: string | undefined;
                } | undefined;
            } | undefined;
            thumbnailPath?: string | undefined;
            thumbnailSize?: number | undefined;
            imageHeight?: number | undefined;
            imageWidth?: number | undefined;
            errorCode?: number | undefined;
            errorMessage?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, "results">, never>>(object: I): S3ProcessResult;
};
export declare const S3ProcessResult_Result: {
    encode(message: S3ProcessResult_Result, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): S3ProcessResult_Result;
    fromJSON(object: any): S3ProcessResult_Result;
    toJSON(message: S3ProcessResult_Result): unknown;
    fromPartial<I extends {
        correlationId?: string | undefined;
        filePath?: string | undefined;
        fileSize?: number | undefined;
        fileSha1?: string | undefined;
        s3ExifData?: {
            gpsDop?: number | undefined;
            gpsAltitude?: number | undefined;
            gpsLatitude?: number | undefined;
            gpsLongitude?: number | undefined;
            gpsTimestamp?: Date | undefined;
            dateTimeOriginal?: string | undefined;
            dateTimeDigitized?: string | undefined;
            userComment?: string | undefined;
            cameraMake?: string | undefined;
            cameraModel?: string | undefined;
            cameraOsVersion?: string | undefined;
        } | undefined;
        s3UploadData?: {
            correlationId?: string | undefined;
            imageType?: number | undefined;
            filename?: string | undefined;
            source?: string | undefined;
            description?: string | undefined;
            category?: string | undefined;
            prefix?: string | undefined;
            contractor?: number | undefined;
            departmentCode?: string | undefined;
            timezoneOffset?: number | undefined;
            dateTaken?: Date | undefined;
            gpsTimestamp?: Date | undefined;
            gpsDop?: number | undefined;
            gpsAltitude?: number | undefined;
            gpsLatitude?: number | undefined;
            gpsLongitude?: number | undefined;
            orderNumber?: number | undefined;
            propertyId?: number | undefined;
            vendorWebImageData?: {
                statusReportId?: number | undefined;
                documentType?: string | undefined;
                sortOrder?: number | undefined;
                hashKey?: string | undefined;
                documentExtendedAttribute?: string | undefined;
                uploadKey?: string | undefined;
                annotationLabel?: string | undefined;
                annotationText?: string | undefined;
            } | undefined;
            inspiImageData?: {
                isFrontOfHouse?: boolean | undefined;
                mainVendorCode?: string | undefined;
                vendorCodeUploaded?: string | undefined;
            } | undefined;
        } | undefined;
        thumbnailPath?: string | undefined;
        thumbnailSize?: number | undefined;
        imageHeight?: number | undefined;
        imageWidth?: number | undefined;
        errorCode?: number | undefined;
        errorMessage?: string | undefined;
    } & {
        correlationId?: string | undefined;
        filePath?: string | undefined;
        fileSize?: number | undefined;
        fileSha1?: string | undefined;
        s3ExifData?: ({
            gpsDop?: number | undefined;
            gpsAltitude?: number | undefined;
            gpsLatitude?: number | undefined;
            gpsLongitude?: number | undefined;
            gpsTimestamp?: Date | undefined;
            dateTimeOriginal?: string | undefined;
            dateTimeDigitized?: string | undefined;
            userComment?: string | undefined;
            cameraMake?: string | undefined;
            cameraModel?: string | undefined;
            cameraOsVersion?: string | undefined;
        } & {
            gpsDop?: number | undefined;
            gpsAltitude?: number | undefined;
            gpsLatitude?: number | undefined;
            gpsLongitude?: number | undefined;
            gpsTimestamp?: Date | undefined;
            dateTimeOriginal?: string | undefined;
            dateTimeDigitized?: string | undefined;
            userComment?: string | undefined;
            cameraMake?: string | undefined;
            cameraModel?: string | undefined;
            cameraOsVersion?: string | undefined;
        } & Record<Exclude<keyof I["s3ExifData"], keyof S3ExifData>, never>) | undefined;
        s3UploadData?: ({
            correlationId?: string | undefined;
            imageType?: number | undefined;
            filename?: string | undefined;
            source?: string | undefined;
            description?: string | undefined;
            category?: string | undefined;
            prefix?: string | undefined;
            contractor?: number | undefined;
            departmentCode?: string | undefined;
            timezoneOffset?: number | undefined;
            dateTaken?: Date | undefined;
            gpsTimestamp?: Date | undefined;
            gpsDop?: number | undefined;
            gpsAltitude?: number | undefined;
            gpsLatitude?: number | undefined;
            gpsLongitude?: number | undefined;
            orderNumber?: number | undefined;
            propertyId?: number | undefined;
            vendorWebImageData?: {
                statusReportId?: number | undefined;
                documentType?: string | undefined;
                sortOrder?: number | undefined;
                hashKey?: string | undefined;
                documentExtendedAttribute?: string | undefined;
                uploadKey?: string | undefined;
                annotationLabel?: string | undefined;
                annotationText?: string | undefined;
            } | undefined;
            inspiImageData?: {
                isFrontOfHouse?: boolean | undefined;
                mainVendorCode?: string | undefined;
                vendorCodeUploaded?: string | undefined;
            } | undefined;
        } & {
            correlationId?: string | undefined;
            imageType?: number | undefined;
            filename?: string | undefined;
            source?: string | undefined;
            description?: string | undefined;
            category?: string | undefined;
            prefix?: string | undefined;
            contractor?: number | undefined;
            departmentCode?: string | undefined;
            timezoneOffset?: number | undefined;
            dateTaken?: Date | undefined;
            gpsTimestamp?: Date | undefined;
            gpsDop?: number | undefined;
            gpsAltitude?: number | undefined;
            gpsLatitude?: number | undefined;
            gpsLongitude?: number | undefined;
            orderNumber?: number | undefined;
            propertyId?: number | undefined;
            vendorWebImageData?: ({
                statusReportId?: number | undefined;
                documentType?: string | undefined;
                sortOrder?: number | undefined;
                hashKey?: string | undefined;
                documentExtendedAttribute?: string | undefined;
                uploadKey?: string | undefined;
                annotationLabel?: string | undefined;
                annotationText?: string | undefined;
            } & {
                statusReportId?: number | undefined;
                documentType?: string | undefined;
                sortOrder?: number | undefined;
                hashKey?: string | undefined;
                documentExtendedAttribute?: string | undefined;
                uploadKey?: string | undefined;
                annotationLabel?: string | undefined;
                annotationText?: string | undefined;
            } & Record<Exclude<keyof I["s3UploadData"]["vendorWebImageData"], keyof VendorWebImageData>, never>) | undefined;
            inspiImageData?: ({
                isFrontOfHouse?: boolean | undefined;
                mainVendorCode?: string | undefined;
                vendorCodeUploaded?: string | undefined;
            } & {
                isFrontOfHouse?: boolean | undefined;
                mainVendorCode?: string | undefined;
                vendorCodeUploaded?: string | undefined;
            } & Record<Exclude<keyof I["s3UploadData"]["inspiImageData"], keyof InspiImageData>, never>) | undefined;
        } & Record<Exclude<keyof I["s3UploadData"], keyof S3UploadData>, never>) | undefined;
        thumbnailPath?: string | undefined;
        thumbnailSize?: number | undefined;
        imageHeight?: number | undefined;
        imageWidth?: number | undefined;
        errorCode?: number | undefined;
        errorMessage?: string | undefined;
    } & Record<Exclude<keyof I, keyof S3ProcessResult_Result>, never>>(object: I): S3ProcessResult_Result;
};
export declare const S3UploadStatusData: {
    encode(message: S3UploadStatusData, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): S3UploadStatusData;
    fromJSON(object: any): S3UploadStatusData;
    toJSON(message: S3UploadStatusData): unknown;
    fromPartial<I extends {
        correlationId?: string | undefined;
        orderNumber?: number | undefined;
        propertyId?: number | undefined;
    } & {
        correlationId?: string | undefined;
        orderNumber?: number | undefined;
        propertyId?: number | undefined;
    } & Record<Exclude<keyof I, keyof S3UploadStatusData>, never>>(object: I): S3UploadStatusData;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
declare type KeysOfUnion<T> = T extends T ? keyof T : never;
export declare type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & Record<Exclude<keyof I, KeysOfUnion<P>>, never>;
export {};
