import * as _m0 from "protobufjs/minimal";
export declare const protobufPackage = "sgt.content.v2";
export declare enum Rotate {
    ROTATE_NONE = 0,
    ROTATE_90 = 1,
    ROTATE_180 = 2,
    ROTATE_270 = 3,
    UNRECOGNIZED = -1
}
export declare function rotateFromJSON(object: any): Rotate;
export declare function rotateToJSON(object: Rotate): string;
export interface VendorWebImageData {
    statusReportId: number;
    documentType: string;
    sortOrder: number;
    hashKey: string;
    documentExtendedAttribute: string;
    uploadKey: string;
    annotationLabel: string;
    annotationText: string;
}
export interface InspiImageData {
    isFrontOfHouse: boolean;
    mainVendorCode: string;
    vendorCodeUploaded: string;
}
/**
 * *****************************
 * Update
 */
export interface UpdateMetadata {
    orderNumber: number;
    propertyId: number;
    imageType: number;
    imageWidth: number;
    imageHeight: number;
    contractorId: number;
    departmentCode: string;
    description: string;
    prefix: string;
    category: string;
    scanDate: Date | undefined;
    releaseDate: Date | undefined;
    source: string;
    guid: string;
}
export declare const VendorWebImageData: {
    encode(message: VendorWebImageData, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): VendorWebImageData;
    fromJSON(object: any): VendorWebImageData;
    toJSON(message: VendorWebImageData): unknown;
    fromPartial<I extends {
        statusReportId?: number | undefined;
        documentType?: string | undefined;
        sortOrder?: number | undefined;
        hashKey?: string | undefined;
        documentExtendedAttribute?: string | undefined;
        uploadKey?: string | undefined;
        annotationLabel?: string | undefined;
        annotationText?: string | undefined;
    } & {
        statusReportId?: number | undefined;
        documentType?: string | undefined;
        sortOrder?: number | undefined;
        hashKey?: string | undefined;
        documentExtendedAttribute?: string | undefined;
        uploadKey?: string | undefined;
        annotationLabel?: string | undefined;
        annotationText?: string | undefined;
    } & Record<Exclude<keyof I, keyof VendorWebImageData>, never>>(object: I): VendorWebImageData;
};
export declare const InspiImageData: {
    encode(message: InspiImageData, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): InspiImageData;
    fromJSON(object: any): InspiImageData;
    toJSON(message: InspiImageData): unknown;
    fromPartial<I extends {
        isFrontOfHouse?: boolean | undefined;
        mainVendorCode?: string | undefined;
        vendorCodeUploaded?: string | undefined;
    } & {
        isFrontOfHouse?: boolean | undefined;
        mainVendorCode?: string | undefined;
        vendorCodeUploaded?: string | undefined;
    } & Record<Exclude<keyof I, keyof InspiImageData>, never>>(object: I): InspiImageData;
};
export declare const UpdateMetadata: {
    encode(message: UpdateMetadata, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number): UpdateMetadata;
    fromJSON(object: any): UpdateMetadata;
    toJSON(message: UpdateMetadata): unknown;
    fromPartial<I extends {
        orderNumber?: number | undefined;
        propertyId?: number | undefined;
        imageType?: number | undefined;
        imageWidth?: number | undefined;
        imageHeight?: number | undefined;
        contractorId?: number | undefined;
        departmentCode?: string | undefined;
        description?: string | undefined;
        prefix?: string | undefined;
        category?: string | undefined;
        scanDate?: Date | undefined;
        releaseDate?: Date | undefined;
        source?: string | undefined;
        guid?: string | undefined;
    } & {
        orderNumber?: number | undefined;
        propertyId?: number | undefined;
        imageType?: number | undefined;
        imageWidth?: number | undefined;
        imageHeight?: number | undefined;
        contractorId?: number | undefined;
        departmentCode?: string | undefined;
        description?: string | undefined;
        prefix?: string | undefined;
        category?: string | undefined;
        scanDate?: Date | undefined;
        releaseDate?: Date | undefined;
        source?: string | undefined;
        guid?: string | undefined;
    } & Record<Exclude<keyof I, keyof UpdateMetadata>, never>>(object: I): UpdateMetadata;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
declare type KeysOfUnion<T> = T extends T ? keyof T : never;
export declare type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & Record<Exclude<keyof I, KeysOfUnion<P>>, never>;
export {};
