"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleSaveTransport = void 0;
const _controllers_1 = require("../_controllers");
const _validation_1 = require("../_validation");
let USER_RESPONSE;
let ERROR = false;
let TOTAL_ERROR_COUNT;
let ERROR_COLLECTION;
let MEDIA_ERROR_COLLECTION;
let ALL_STATION_DATA;
let MEDIA = {};
let LUGGAGE;
let LANGUAGE;
let STATIONS;
// function for checking that It should include in Answer or not
const validateData = (visible, hidden, activated) => {
    if (activated &&
        (0, _controllers_1.activatedBy)(activated, USER_RESPONSE, LUGGAGE, LANGUAGE, ALL_STATION_DATA)) {
        return true;
    }
    if (visible === "N")
        return false;
    if (!activated)
        return true;
    return false;
};
// get user answer
const getAnswerByQuestion = (props) => {
    var _a, _b, _c, _d;
    let { Name, Required, Validation, PrePopulate, Answers, Type, StationName } = props;
    // user response from satation list
    let answer = USER_RESPONSE[Name].UserResponse;
    let mediaResponse = [];
    // handle media in case of single select
    if (Type === "SingleSelect") {
        // check if it have the Photos label include
        if (answer && answer[1]) {
            // get all lebela
            let photo = (_a = answer[1]) === null || _a === void 0 ? void 0 : _a.Photos;
            let video = (_b = answer[1]) === null || _b === void 0 ? void 0 : _b.Videos;
            let documents = (_c = answer[1]) === null || _c === void 0 ? void 0 : _c.Documents;
            let screenShot = (_d = answer[1]) === null || _d === void 0 ? void 0 : _d.ScreenShots;
            mediaResponse = [];
            // loop over Photos labels
            photo === null || photo === void 0 ? void 0 : photo.forEach((item, i) => {
                var _a, _b, _c, _d;
                // get media response
                let media = ((_b = (_a = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _a === void 0 ? void 0 : _a[item.Label]) === null || _b === void 0 ? void 0 : _b.response)
                    ? (_d = (_c = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _c === void 0 ? void 0 : _c[item.Label]) === null || _d === void 0 ? void 0 : _d.response
                    : [];
                mediaResponse.push({
                    Type: "Photo",
                    Label: item.Label,
                    Media: [{ Id: [], GUID: [] }],
                });
                // check if it pass min validation
                if (item.Min <= media.length && ((item === null || item === void 0 ? void 0 : item.Max) || 1000) >= media.length) {
                    // loop over the media files
                    media.forEach((data) => {
                        // push on same label
                        mediaResponse.forEach((file, i) => {
                            if (file.Label === item.Label) {
                                mediaResponse[i].Media[0].Id.push(parseInt(data.imageId));
                            }
                        });
                    });
                }
                else {
                    ERROR = true;
                    MEDIA_ERROR_COLLECTION.push({
                        Question: Name,
                        Label: item.Label,
                    });
                }
            });
            // loop over Videos labels
            video === null || video === void 0 ? void 0 : video.forEach((item, i) => {
                var _a, _b, _c, _d;
                // get media response
                let media = ((_b = (_a = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _a === void 0 ? void 0 : _a[item.Label]) === null || _b === void 0 ? void 0 : _b.response)
                    ? (_d = (_c = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _c === void 0 ? void 0 : _c[item.Label]) === null || _d === void 0 ? void 0 : _d.response
                    : [];
                mediaResponse.push({
                    Type: "Video",
                    Label: item.Label,
                    Media: [{ Id: [], GUID: [] }],
                });
                // check if it pass min validation
                if (item.Min <= media.length && ((item === null || item === void 0 ? void 0 : item.Max) || 1000) >= media.length) {
                    // loop over the media files
                    media.forEach((data) => {
                        // push on same label
                        mediaResponse.forEach((file, i) => {
                            if (file.Label === item.Label) {
                                mediaResponse[i].Media[0].Id.push(parseInt(data.imageId));
                            }
                        });
                    });
                }
                else {
                    ERROR = true;
                    MEDIA_ERROR_COLLECTION.push({
                        Question: Name,
                        Label: item.Label,
                    });
                }
            });
            // loop over Documents labels
            documents === null || documents === void 0 ? void 0 : documents.forEach((item, i) => {
                var _a, _b, _c, _d;
                // get media response
                let media = ((_b = (_a = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _a === void 0 ? void 0 : _a[item.Label]) === null || _b === void 0 ? void 0 : _b.response)
                    ? (_d = (_c = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _c === void 0 ? void 0 : _c[item.Label]) === null || _d === void 0 ? void 0 : _d.response
                    : [];
                mediaResponse.push({
                    Type: "Document",
                    Label: item.Label,
                    Media: [{ Id: [], GUID: [] }],
                });
                // check if it pass min validation
                if (item.Min <= media.length && ((item === null || item === void 0 ? void 0 : item.Max) || 1000) >= media.length) {
                    // loop over the media files
                    media.forEach((data) => {
                        // push on same label
                        mediaResponse.forEach((file, i) => {
                            if (file.Label === item.Label) {
                                mediaResponse[i].Media[0].Id.push(parseInt(data.imageId));
                            }
                        });
                    });
                }
                else {
                    ERROR = true;
                    MEDIA_ERROR_COLLECTION.push({
                        Question: Name,
                        Label: item.Label,
                    });
                }
            });
            // loop over ScreenShots labels
            screenShot === null || screenShot === void 0 ? void 0 : screenShot.forEach((item, i) => {
                var _a, _b, _c, _d;
                // get media response
                let media = ((_b = (_a = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _a === void 0 ? void 0 : _a[item.Label]) === null || _b === void 0 ? void 0 : _b.response)
                    ? (_d = (_c = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _c === void 0 ? void 0 : _c[item.Label]) === null || _d === void 0 ? void 0 : _d.response
                    : [];
                mediaResponse.push({
                    Type: "ScreenShot",
                    Label: item.Label,
                    Media: [{ Id: [], GUID: [] }],
                });
                // check if it pass min validation
                if (item.Min <= media.length && ((item === null || item === void 0 ? void 0 : item.Max) || 1000) >= media.length) {
                    // loop over the media files
                    media.forEach((data) => {
                        // push on same label
                        mediaResponse.forEach((file, i) => {
                            if (file.Label === item.Label) {
                                mediaResponse[i].Media[0].Id.push(parseInt(data.imageId));
                            }
                        });
                    });
                }
                else {
                    ERROR = true;
                    MEDIA_ERROR_COLLECTION.push({
                        Question: Name,
                        Label: item.Label,
                    });
                }
            });
            if (mediaResponse.length > 0) {
                return { Name: Name, Values: [answer[0]], MediaGroup: mediaResponse };
            }
            return { Name: Name, Values: [answer[0]] };
        }
    }
    // handle media in case of multi-select
    if (Type === "MultiSelect") {
        // check if user have answered it
        if ((answer === null || answer === void 0 ? void 0 : answer.length) > 0) {
            mediaResponse = [];
            // loop over user response
            answer.forEach((options) => {
                // let userRes = options[0]; // user option
                let media = options && options[1]; // user media labels
                // let terminate = options && options[2]; // terminate key
                // get all media labels
                let photo = media === null || media === void 0 ? void 0 : media.Photos;
                let video = media === null || media === void 0 ? void 0 : media.Videos;
                let documents = media === null || media === void 0 ? void 0 : media.Documents;
                let screenShot = media === null || media === void 0 ? void 0 : media.ScreenShots;
                // loop over photo labels
                photo === null || photo === void 0 ? void 0 : photo.forEach((item) => {
                    var _a, _b, _c, _d;
                    let media = ((_b = (_a = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _a === void 0 ? void 0 : _a[item.Label]) === null || _b === void 0 ? void 0 : _b.response)
                        ? (_d = (_c = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _c === void 0 ? void 0 : _c[item.Label]) === null || _d === void 0 ? void 0 : _d.response
                        : [];
                    mediaResponse.push({
                        Type: "Photo",
                        Label: item.Label,
                        Media: [{ Id: [], GUID: [] }],
                    });
                    if (item.Min <= media.length && ((item === null || item === void 0 ? void 0 : item.Max) || 1000) >= media.length) {
                        media.forEach((data) => {
                            mediaResponse.forEach((file, i) => {
                                if (file.Label === item.Label) {
                                    mediaResponse[i].Media[0].Id.push(parseInt(data.imageId));
                                }
                            });
                        });
                    }
                    else {
                        ERROR = true;
                        MEDIA_ERROR_COLLECTION.push({
                            Question: Name,
                            Label: item.Label,
                        });
                    }
                });
                // loop over video labels
                video === null || video === void 0 ? void 0 : video.forEach((item) => {
                    var _a, _b, _c, _d;
                    let media = ((_b = (_a = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _a === void 0 ? void 0 : _a[item.Label]) === null || _b === void 0 ? void 0 : _b.response)
                        ? (_d = (_c = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _c === void 0 ? void 0 : _c[item.Label]) === null || _d === void 0 ? void 0 : _d.response
                        : [];
                    mediaResponse.push({
                        Type: "Video",
                        Label: item.Label,
                        Media: [{ Id: [], GUID: [] }],
                    });
                    if (item.Min <= media.length && ((item === null || item === void 0 ? void 0 : item.Max) || 1000) >= media.length) {
                        media.forEach((data) => {
                            mediaResponse.forEach((file, i) => {
                                if (file.Label === item.Label) {
                                    mediaResponse[i].Media[0].Id.push(parseInt(data.imageId));
                                }
                            });
                        });
                    }
                    else {
                        ERROR = true;
                        MEDIA_ERROR_COLLECTION.push({
                            Question: Name,
                            Label: item.Label,
                        });
                    }
                });
                // loop over Documents labels
                documents === null || documents === void 0 ? void 0 : documents.forEach((item) => {
                    var _a, _b, _c, _d;
                    let media = ((_b = (_a = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _a === void 0 ? void 0 : _a[item.Label]) === null || _b === void 0 ? void 0 : _b.response)
                        ? (_d = (_c = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _c === void 0 ? void 0 : _c[item.Label]) === null || _d === void 0 ? void 0 : _d.response
                        : [];
                    mediaResponse.push({
                        Type: "Document",
                        Label: item.Label,
                        Media: [{ Id: [], GUID: [] }],
                    });
                    if (item.Min <= media.length && ((item === null || item === void 0 ? void 0 : item.Max) || 1000) >= media.length) {
                        media.forEach((data) => {
                            mediaResponse.forEach((file, i) => {
                                if (file.Label === item.Label) {
                                    mediaResponse[i].Media[0].Id.push(parseInt(data.imageId));
                                }
                            });
                        });
                    }
                    else {
                        ERROR = true;
                        MEDIA_ERROR_COLLECTION.push({
                            Question: Name,
                            Label: item.Label,
                        });
                    }
                });
                // loop over screenShot labels
                screenShot === null || screenShot === void 0 ? void 0 : screenShot.forEach((item) => {
                    var _a, _b, _c, _d;
                    let media = ((_b = (_a = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _a === void 0 ? void 0 : _a[item.Label]) === null || _b === void 0 ? void 0 : _b.response)
                        ? (_d = (_c = MEDIA === null || MEDIA === void 0 ? void 0 : MEDIA[Name]) === null || _c === void 0 ? void 0 : _c[item.Label]) === null || _d === void 0 ? void 0 : _d.response
                        : [];
                    mediaResponse.push({
                        Type: "ScreenShot",
                        Label: item.Label,
                        Media: [{ Id: [], GUID: [] }],
                    });
                    if (item.Min <= media.length && ((item === null || item === void 0 ? void 0 : item.Max) || 1000) >= media.length) {
                        media.forEach((data) => {
                            mediaResponse.forEach((file, i) => {
                                if (file.Label === item.Label) {
                                    mediaResponse[i].Media[0].Id.push(parseInt(data.imageId));
                                }
                            });
                        });
                    }
                    else {
                        ERROR = true;
                        MEDIA_ERROR_COLLECTION.push({
                            Question: Name,
                            Label: item.Label,
                        });
                    }
                });
            });
            let DATA = answer.map((item) => item[0]);
            if (mediaResponse.length > 0) {
                return { Name: Name, Values: DATA, MediaGroup: mediaResponse };
            }
            return { Name: Name, Values: DATA };
        }
    }
    if (Validation) {
        // if question have validation
        let str = answer;
        let valid = (0, _validation_1.handleValidate)(props, str);
        if (valid === "true") {
            return { Name: Name, Values: answer };
        }
        else {
            ERROR_COLLECTION.push({ QuestionName: Name, error: valid });
            if (StationName)
                TOTAL_ERROR_COUNT[StationName] = TOTAL_ERROR_COUNT[StationName]
                    ? TOTAL_ERROR_COUNT[StationName] + 1
                    : 1;
            ERROR = true;
            return null;
        }
    }
    // if question have prepopulated values and response is null
    if (PrePopulate && answer === null) {
        if (PrePopulate.PrePopulatedBy.LuggageSource) {
            let preValue = (0, _controllers_1.getPrePopulatedValue)(LUGGAGE, PrePopulate.PrePopulatedBy.Key, PrePopulate.PrePopulatedBy.LuggageSource);
            if (preValue[0] !== "DEFAULT") {
                return { Name: Name, Values: preValue };
            }
        }
    }
    // if answer have default option and
    if (Answers && answer === null) {
        if (Type === "MultiSelect") {
            let defaultValue = (0, _controllers_1.getDefaultValueSelect)(Answers);
            if (defaultValue.length > 0) {
                answer = defaultValue;
                return { Name: Name, Values: defaultValue };
            }
        }
        if (Type === "SingleSelect") {
            let defaultValue = (0, _controllers_1.getDefaultValue)(Answers);
            if (defaultValue !== "DEFAULT") {
                answer = [defaultValue];
                return { Name: Name, Values: [defaultValue] };
            }
        }
    }
    // if question is required and response is null
    if (Required === "Y" && answer === null) {
        ERROR_COLLECTION.push({
            QuestionName: Name,
            error: "This is required field",
        });
        if (StationName)
            TOTAL_ERROR_COUNT[StationName] = TOTAL_ERROR_COUNT[StationName]
                ? TOTAL_ERROR_COUNT[StationName] + 1
                : 1;
        ERROR = true;
        return null;
    }
    return { Name: Name, Values: answer };
};
// handle questions
const handleGetAnswerByQuestions = (props) => {
    let ANSWERS = [];
    props.forEach((item) => {
        let { Visible, Hidden, ActivatedBy } = item;
        if (validateData(Visible, Hidden, ActivatedBy)) {
            let val = getAnswerByQuestion(item);
            if (val !== null)
                ANSWERS.push(val);
        }
    });
    return ANSWERS;
};
// handle question group
const handleGetAnswerByQuestionGroup = (props) => {
    let { Visible, Hidden, ActivatedBy, Questions } = props;
    let ANSWERS = [];
    if (validateData(Visible, Hidden, ActivatedBy))
        ANSWERS = ANSWERS.concat(handleGetAnswerByQuestions(Questions));
    return ANSWERS;
};
// handle station
const handleGetAnsweByStation = (props) => {
    let { QuestionGroups } = props;
    let ANSWERS = [];
    QuestionGroups.forEach((item) => {
        let { Visible, Hidden, ActivatedBy } = item;
        if (validateData(Visible, Hidden, ActivatedBy))
            ANSWERS = ANSWERS.concat(handleGetAnswerByQuestionGroup(item));
    });
    return ANSWERS;
};
const handleSaveTransport = (station, Question, Luggage, Language, MediaData, All_Station) => {
    USER_RESPONSE = Question;
    LUGGAGE = Luggage;
    LANGUAGE = Language;
    STATIONS = station;
    MEDIA = MediaData;
    ALL_STATION_DATA = All_Station;
    ERROR = false;
    TOTAL_ERROR_COUNT = {};
    let ANSWERS = [];
    ERROR_COLLECTION = [];
    MEDIA_ERROR_COLLECTION = [];
    Object.entries(STATIONS).forEach((item) => {
        let { Visible, Hidden, ActivatedBy } = item[1];
        if (validateData(Visible, Hidden, ActivatedBy))
            ANSWERS = ANSWERS.concat(handleGetAnsweByStation(item[1]));
    });
    return {
        error: ERROR,
        ANSWERS: ANSWERS.filter((item) => item.Values !== null),
        errorMsg: ERROR_COLLECTION,
        mediaError: MEDIA_ERROR_COLLECTION,
    };
};
exports.handleSaveTransport = handleSaveTransport;
